`include "../lib/firdefs.h"
`ifndef FIR_ORDER
`define FIR_ORDER 5
`endif
module
firengine
(
z1
,
z2
,
z3
,
z4
,
z5
,
z6
,
z7
,
z8
,
z9
,
z10
,
z11
,
z12
,
z13
,
z14
,
z15
,
z16
,
z17
,
z18
,
z19
);
parameter
z20
=
1
;
parameter
z21
=
64
;
parameter
z22
=
16
;
parameter
z23
=
20
;
parameter
z24
=
4
;
parameter
z25
=
10
;
parameter
z26
=
`FIR_ORDER
;
parameter
z27
=
3
;
parameter
z28
=
2
;
parameter
z29
=
18
;
parameter
z30
=
z27
+
z22
+
4
;
input
z1
;
input
z2
;
input
z3
;
input
z5
;
input
z7
;
input
[
31
:
0
]
z4
;
input
[
31
:
0
]
z6
;
output
[
31
:
0
]
z8
;
output
z9
;
input
z10
;
output
z11
;
input
z12
;
input
[
7
:
0
]
z13
;
input
[
z21
-
1
:
0
]
z14
;
output
z15
;
input
z16
;
output
[
7
:
0
]
z17
;
output
[
z21
-
1
:
0
]
z18
;
output
[
7
:
0
]
z19
;
wire
z31
=
0
,
z32
=
1
;
assign
z9
=
z32
;
wire
z33
,
z34
,
z35
;
reg
z36
,
z37
,
z38
,
z39
;
reg
[
31
:
0
]
z40
;
reg
[
15
:
0
]
z41
;
swrstat
#
(
"FIR"
,
z26
)
z42
(
z1
,
z3
,
z5
,
z4
,
z6
,
z8
);
wire
[
15
:
0
]
z43
;
swrbank
#
(
0
,
16
)
z44
(
z1
,
z3
,
z5
,
z4
,
z43
);
wire
z45
=
z43
[
0
];
wire
z46
=
z43
[
9
];
wire
z47
=
z43
[
12
];
wire
z48
=
z43
[
13
];
always
@(
posedge
z1
)
begin
z39
<=
!
z40
[
0
]
||
z2
;
if
(
z45
)
z40
<=
z6
;
if
(
z46
)
z41
<=
z6
[
15
:
0
];
end
wire
z49
=
z32
;
wire
[
3
:
0
]
z50
=
z40
[
11
:
8
];
wire
[
3
:
0
]
z51
=
z40
[
15
:
12
];
wire
z52
=
!
z51
[
0
];
wire
z53
=
z51
[
0
];
wire
z54
=
z50
[
3
];
wire
z55
=
z51
[
3
];
always
@(
posedge
z1
)
begin
z36
<=
z34
&&
z33
;
z37
<=
z36
;
end
always
@(
posedge
z10
)
z38
<=
z12
;
wire
[
31
:
0
]
z56
;
fifoNxMfmt
#
(
z21
,
32
)
z57
(
z10
,
z39
,
z50
,
z11
,
z38
,
z14
,
z1
,
z39
,
4'h8
,
z34
,
z36
,
z56
);
wire
[
z29
-
1
:
0
]
z58
;
wire
z59
,
z60
,
z61
;
firfilter
#
(
z26
,
z22
,
z23
,
z29
,
z24
,
z25
,
`ANTISYM
|
`CAUSAL
)
z62
(
z1
,
z39
,
z47
,
z48
,
z6
,
z33
,
z37
,
z54
?
z56
[
31
:
16
]:
z56
[
15
:
0
],
z59
,
z58
,
z31
);
wire
[
z30
-
1
:
0
]
z63
,
z64
,
z65
;
srmul
#
(
z29
,
16
,
z30
)
z66
(
z58
,
z41
,
z63
,
z1
,
z32
);
roundN2Mc
#
(
z30
,
z22
,
z27
)
z67
(
z63
,
z64
,
z52
,
z49
,
z1
,
z60
);
roundN2Mc
#
(
z30
,
8
,
z27
)
z68
(
z64
,
z65
,
z53
,
z49
,
z1
,
z61
);
wire
z69
,
z70
;
wire
[
31
:
0
]
z71
;
reg
z72
,
z73
,
z74
,
z75
;
fifoNxM
#
(
32
,
32
)
z76
(
z1
,
z39
,
z69
,
z37
,
z56
,
z1
,
z39
,
z70
,
z73
,
z71
);
wire
[
15
:
0
]
z77
=
z65
[
z30
-
z27
-
1
:
z30
-
z27
-
z22
];
reg
[
31
:
0
]
z78
;
always
@(
posedge
z1
)
begin
z72
<=
z59
;
z73
<=
z72
;
z74
<=
z73
;
z75
<=
z74
;
z78
<=
z55
?
{
z77
,
z71
[
15
:
0
]}
:
{
16'h0
,
z77
};
end
fifoNxMfmti
#
(
z21
,
32
)
z79
(
z10
,
z39
,
z51
,
z15
,
z16
,
z18
,
z1
,
z39
,
4'h8
,
z35
,
z75
,
z78
);
endmodule
module
firfilter
(
z80
,
z81
,
z82
,
z83
,
z84
,
z33
,
z85
,
z86
,
z87
,
z88
,
z89
);
parameter
z26
=
4
;
parameter
z21
=
16
;
parameter
z23
=
16
;
parameter
z90
=
16
;
parameter
z24
=
8
;
parameter
z25
=
4
;
parameter
z91
=
`ANTISYM
;
parameter
ANTISYM
=(
z91
&
`ANTISYM
)?
1
:
0
;
parameter
z92
=(
z91
&
`DELAY1
)?
1
:
0
;
parameter
PREOUT
=(
z91
&
`PREOUT
)?
1
:
0
;
parameter
CAUSAL
=(
z91
&
`CAUSAL
)?
1
:
0
;
parameter
z93
=(
z91
&
`XTAPS
)?
5
:
4
;
parameter
XCOEF
=(
z91
&
`XCOEF
)?
1
:
0
;
parameter
z94
=
z21
+
z23
-
1
;
parameter
z29
=
z90
+
z24
+
z25
;
parameter
z22
=(
PREOUT
==
1
)?
z29
:
z90
;
parameter
z95
=(
2
**
z26
);
parameter
z96
=(
z26
>
1
)?
(
z95
-
3
):(
z95
-
2
);
parameter
z97
=
20
;
input
z80
,
z81
;
input
z82
,
z83
;
input
[
31
:
0
]
z84
;
input
z85
;
input
[
z21
-
1
:
0
]
z86
;
output
z33
,
z87
;
output
[
z22
-
1
:
0
]
z88
;
input
z89
;
wire
z31
=
0
,
z32
=
1
;
wire
[
z21
-
1
:
0
]
z98
=
0
;
wire
signed
[
z21
-
1
:
0
]
z99
,
z100
,
z101
;
wire
signed
[
z21
-
1
:
0
]
z102
[
z95
-
1
:
0
],
z103
[
z95
-
1
:
0
];
reg
signed
[
z21
-
1
:
0
]
z104
[
z95
-
1
:
0
],
z105
[
z95
-
1
:
0
];
reg
signed
[
z21
:
0
]
z106
[
z95
-
1
:
0
];
reg
signed
[
z94
+
1
:
0
]
z107
[
z95
-
1
:
0
];
wire
signed
[
z90
+
z25
:
0
]
z108
[
z95
-
1
:
0
];
wire
signed
[
z29
-
1
:
0
]
z109
,
z110
,
z111
;
reg
signed
[
z29
-
1
:
0
]
z112
[
z95
-
1
:
0
][
z26
:
0
];
reg
signed
[
z29
-
1
:
0
]
z113
,
z114
;
wire
signed
[
z23
-
1
:
0
]
z115
[
z95
-
1
:
0
];
reg
signed
[
z23
-
1
:
0
]
z116
[
z95
-
1
:
0
];
wire
signed
[
z23
-
1
:
0
]
z117
=
z84
[
32
-
XCOEF
-
1
:
32
-
XCOEF
-
z23
];
wire
[
27
:
0
]
z118
;
reg
[
z93
:
0
]
z119
;
reg
[
z93
-
1
:
0
]
z120
,
z121
,
z122
,
z123
,
z124
,
z125
;
reg
[
9
:
0
]
z126
;
reg
z33
,
z127
,
z128
,
z129
,
z130
,
z131
,
z132
,
z133
,
z134
,
z135
,
z136
,
z137
,
z2
,
z138
,
z139
;
wire
z140
=
z2
||
(
z127
&&
(
z125
==
z124
));
wire
z141
=
(
z126
==
0
);
wire
z142
=
(
z127
&&
z118
[
27
]
&&
!
z141
);
always
@(
posedge
z80
)
begin
if
(
z140
)
z125
<=
0
;
else
if
(
z127
)
z125
<=
z125
+
1
;
z120
<=
z118
[
5
:
0
];
z121
<=
z118
[
11
:
6
];
z122
<=
z118
[
17
:
12
];
z119
<=
z118
[
23
:
18
];
z131
<=
(
z127
&&
z118
[
24
])
||
z2
;
z132
<=
(
z127
&&
z118
[
25
]
&&
!
z130
)
||
z2
;
z136
<=
(
z127
&&
z118
[
26
]);
z137
<=
(
z127
&&
z118
[
27
]
&&
((
CAUSAL
==
0
)
||
z141
));
z128
<=
z127
;
z133
<=
z83
;
z134
<=
z82
&&
z84
[
31
];
z135
<=
z82
&&
z2
;
z2
<=
z81
;
z138
<=
z2
;
z123
<=
z83
?
z124
:
z122
;
if
(
z134
)
z126
<=
z84
[
9
:
0
];
else
if
(
z142
)
z126
<=
z126
-
1
;
if
(
z134
)
z124
<=
z84
[
21
:
16
];
if
(
z134
)
z129
<=
z84
[
28
];
if
(
z134
)
z130
<=
z84
[
29
];
end
srlMxN
#
(
z93
,
28
)
z143
(
z80
,
z135
,
z125
,
z84
[
27
:
0
],
z118
);
wire
z144
,
z145
,
z146
;
wire
[
3
:
0
]
z147
=
1
+
z26
+
0
;
wire
[
3
:
0
]
z148
=
1
+
z26
+
1
+
z92
+(
1
-
PREOUT
);
srl16xNp
z149
(
z80
,
z32
,
z147
,
z128
,
z146
);
srl16xNp
z150
(
z80
,
z32
,
z147
,
z136
,
z144
);
srl16xNp
z151
(
z80
,
z32
,
z148
,
z137
,
z145
);
reg
[
3
:
0
]
z152
;
wire
[
3
:
0
]
z153
=
z152
-
z89
;
always
@(
posedge
z80
)
begin
if
(
z2
)
z152
<=
z89
;
else
if
(
z131
&!
z85
)
z152
<=
z152
-
1
;
else
if
(!
z131
&
z85
)
z152
<=
z152
+
1
;
z33
<=
(
z153
<
8
)
||
(
z153
==
15
);
z127
<=
(
z153
>
2
)
&&
(
z153
!=
15
);
end
srl16xN
#
(
z21
)
z154
(
z80
,
z85
|
z2
,
z152
,
z2
?
z98
:
z86
,
z99
);
assign
z101
=
(
z129
&&
ANTISYM
)?
-
z102
[
z96
]
:
z102
[
z96
];
srlMxN
#
(
z93
+
1
,
z21
)
z155
(
z80
,
z131
,
z119
,
z101
,
z100
);
genvar
z156
,
z157
;
srlMxN
#
(
z93
,
z21
)
z158
(
z80
,
z131
,
z120
,
z99
,
z102
[
0
]);
srlMxN
#
(
z93
,
z21
)
z159
(
z80
,
z132
,
z121
,
z100
,
z103
[
z95
-
1
]);
srlMxN
#
(
z93
,
z23
)
z160
(
z80
,
z133
,
z123
,
z117
,
z115
[
0
]);
generate
for
(
z156
=
1
;
z156
<
z95
;
z156
=
z156
+
1
)
begin
:
z161
srlMxN
#
(
z93
,
z21
)
z162
(
z80
,
z131
,
z120
,
z102
[
z156
-
1
],
z102
[
z156
]);
srlMxN
#
(
z93
,
z21
)
z163
(
z80
,
z132
,
z121
,
z103
[
z156
],
z103
[
z156
-
1
]);
srlMxN
#
(
z93
,
z23
)
z164
(
z80
,
z133
,
z123
,
z115
[
z156
-
1
],
z115
[
z156
]);
end
endgenerate
generate
for
(
z156
=
0
;
z156
<
z95
;
z156
=
z156
+
1
)
begin
:
z165
always
@(
posedge
z80
)
z104
[
z156
]
<=
z102
[
z156
];
always
@(
posedge
z80
)
z105
[
z156
]
<=
z103
[
z156
];
always
@(
posedge
z80
)
z106
[
z156
]
<=
z104
[
z156
]
+
z105
[
z156
];
always
@(
posedge
z80
)
z116
[
z156
]
<=
z115
[
z156
];
always
@(
posedge
z80
)
z107
[
z156
]
<=
z106
[
z156
]
*
z116
[
z156
];
assign
z108
[
z156
]
=
z107
[
z156
][
XCOEF
+
z94
:
XCOEF
+
z94
-
z90
-
z25
];
end
endgenerate
generate
for
(
z157
=
0
;
z157
<
z26
;
z157
=
z157
+
1
)
begin
:
z166
for
(
z156
=
0
;
z156
<(
2
**
z157
);
z156
=
z156
+
1
)
begin
:
z167
always
@(
posedge
z80
)
z112
[
z156
][
z157
]
<=
(
z157
+
1
==
z26
)?
z108
[
z156
+
z156
]
+
z108
[
z156
+
z156
+
1
]
:
z112
[
z156
+
z156
][
z157
+
1
]
+
z112
[
z156
+
z156
+
1
][
z157
+
1
];
end
end
endgenerate
assign
z109
=
z112
[
0
][
0
];
assign
z110
=
z109
+
z113
;
always
@(
posedge
z80
)
if
(
z146
)
z113
<=
z144
?
z110
:
z109
;
always
@(
posedge
z80
)
z114
<=
z113
;
wire
[
z29
-
1
:
0
]
z168
=
z92
?
z114
:
z113
;
wire
z169
;
wire
[
z29
-
1
:
0
]
z170
;
roundN2Mc
#
(
z29
,
z90
,
z24
)
z171
(
z168
,
z170
,
z32
,
z32
,
z80
,
z169
);
assign
z87
=
z145
;
assign
z88
=
(
PREOUT
==
1
)?
z168
:
z170
[
z29
-
z24
-
1
:
z29
-
z24
-
z90
];
endmodule
