`include "../lib/firdefs.h"
`ifndef TFDD_ORDER
`define TFDD_ORDER 1
`endif
`ifndef TFDD_MDW
`define TFDD_MDW 12
`endif
`define CFIRFLG `XCOEF
`ifdef TFDD_XTAPS
`define PFIRFLG `XCOEF|`PREOUT|`XTAPS
`else
`define PFIRFLG `XCOEF|`PREOUT
`endif
`ifndef TFDD_RTAPS
`define TFDD_RTAPS 8
`endif
module
z1
#
(
z2
=
1
,
z3
=
64
)
(
input
[
1
:
0
]
z4
,
input
z5
,
input
z6
,
input
[
31
:
0
]
z7
,
input
z8
,
input
[
31
:
0
]
z9
,
input
z10
,
output
[
31
:
0
]
z11
,
output
z12
,
input
z13
,
output
z14
,
input
z15
,
input
[
7
:
0
]
z16
,
input
[
z3
-
1
:
0
]
z17
,
output
z18
,
input
z19
,
output
[
7
:
0
]
z20
,
output
[
z3
-
1
:
0
]
z21
,
output
[
7
:
0
]
z22
);
tfddengine
#
(
z2
,
z3
,
12
,
1
,
8
)
z23
(
z4
,
z5
,
z6
,
z7
,
z8
,
z9
,
z10
,
z11
,
z12
,
z13
,
z14
,
z15
,
z16
,
z17
,
z18
,
z19
,
z20
,
z21
,
z22
);
endmodule
module
tfddengine
(
z4
,
z5
,
z6
,
z7
,
z8
,
z9
,
z10
,
z11
,
z12
,
z13
,
z14
,
z15
,
z16
,
z17
,
z18
,
z19
,
z20
,
z21
,
z22
);
parameter
z2
=
1
;
parameter
z3
=
64
;
parameter
z24
=
`TFDD_MDW
;
parameter
z25
=
`TFDD_ORDER
;
parameter
z26
=
`TFDD_RTAPS
;
localparam
z27
=(
z24
>
12
)?
7
:
(
z24
>
6
)?
6
:
(
z24
>
3
)?
5
:
4
;
`ifdef PIC8
localparam
z28
=
4
;
localparam
z29
=
4
;
`else
localparam
z28
=
0
;
localparam
z29
=
3
;
`endif
`ifdef SYS_CLKF2_MASK
localparam
z30
=(
`SYS_CLKF2_MASK
>>
(
z2
-
1
))
&
1
;
localparam
z31
=(
z30
>
0
)?
`SYS_CLKF2
:
`SYS_CLKF
;
`else
localparam
z30
=
0
;
localparam
z31
=
`SYS_CLKF
;
`endif
localparam
z32
=
z31
*
1000000
;
input
[
1
:
0
]
z4
;
input
z5
;
input
z6
;
input
[
1
:
0
]
z8
;
input
[
1
:
0
]
z10
;
input
[
31
:
0
]
z7
;
input
[
31
:
0
]
z9
;
output
[
31
:
0
]
z11
;
output
z12
;
input
z13
;
output
z14
;
input
z15
;
input
[
7
:
0
]
z16
;
input
[
z3
-
1
:
0
]
z17
;
output
z18
;
input
z19
;
output
[
7
:
0
]
z20
;
output
[
z3
-
1
:
0
]
z21
;
output
[
7
:
0
]
z22
;
wire
z33
=
0
,
z34
=
1
;
assign
z12
=
z34
;
assign
z20
=
0
;
wire
z35
=
z4
[
z30
];
wire
z36
=
z8
[
z30
];
wire
z37
=
z10
[
z30
];
wire
[
31
:
0
]
z38
;
wire
[
31
:
0
]
z39
=
z32
;
wire
z40
,
z41
,
z42
,
z43
;
reg
z44
,
z45
,
z46
,
z47
,
z48
,
z49
;
always
@(
posedge
z13
)
z48
<=
z15
;
swrstat
#
(
"TFDD"
,
z25
,
z24
,
z26
,
0
,
0
,
0
,
z31
)
z50
(
z35
,
z6
,
z36
,
z7
,
z9
,
z11
);
wire
[
15
:
0
]
z51
;
swrbank
#
(
0
,
16
)
z52
(
z35
,
z6
,
z36
,
z7
,
z51
);
wire
z53
=
z51
[
0
],
z54
=
z51
[
1
],
z55
=
z51
[
2
],
z56
=
z51
[
3
],
z57
=
z51
[
4
],
z58
=
z51
[
5
],
z59
=
z51
[
6
],
z60
=
z51
[
7
];
wire
z61
=
z51
[
8
],
z62
=
z51
[
9
],
z63
=
z51
[
10
],
z64
=
z51
[
11
],
z65
=
z51
[
12
],
z66
=
z51
[
13
],
z67
=
z51
[
14
],
z68
=
z51
[
15
];
reg
[
31
:
0
]
z69
;
reg
[
z24
-
1
:
0
]
z70
;
reg
[
7
:
0
]
z71
,
z72
;
reg
[
11
:
0
]
z73
;
reg
[
31
:
0
]
z74
;
always
@(
posedge
z35
)
begin
if
(
z5
)
z69
<=
0
;
else
if
(
z53
)
z69
<=
z9
;
if
(
z5
)
z70
<=
0
;
else
if
(
z54
)
z70
<=
z9
;
if
(
z5
)
z71
<=
0
;
else
if
(
z58
)
z71
<=
z9
;
if
(
z5
)
z73
<=
0
;
else
if
(
z62
)
z73
<=
z9
;
if
(
z5
)
z74
<=
0
;
else
if
(
z56
)
z74
<=
z9
;
if
(
z5
)
z72
<=
0
;
else
if
(
z60
)
z72
<=
z9
;
end
wire
z75
=
!
z69
[
0
];
wire
z76
=
z69
[
0
];
wire
z77
=
z69
[
1
];
wire
z78
=
z69
[
2
];
wire
z79
=
z69
[
3
];
wire
z80
=
z69
[
4
];
wire
z81
=
z69
[
5
];
wire
z82
=
z69
[
6
];
wire
z83
=
z69
[
7
];
wire
[
3
:
0
]
z84
=
z69
[
11
:
8
];
wire
[
3
:
0
]
z85
=
z69
[
15
:
12
];
wire
[
2
:
0
]
z86
=
z69
[
18
:
16
];
wire
[
3
:
0
]
z87
=
z69
[
23
:
20
];
wire
z88
=
z34
;
wire
z89
=
!
z85
[
3
]
&&
!
z83
;
wire
z90
=
z85
[
0
];
wire
z91
=
z85
[
2
];
wire
z92
=
z35
;
wire
z93
=
!
z82
;
wire
z94
=
z80
?
z78
:
z72
[
0
];
fifoNxMfmt
#
(
z3
,
32
)
z95
(
z13
,
z75
,
z84
,
z14
,
z48
,
z17
,
z92
,
z75
,
4'h8
,
z40
,
z44
,
z38
);
reg
z96
,
z97
;
reg
[
4
:
0
]
z98
;
wire
z99
=
(
z44
||
z96
);
wire
z100
=
(
z98
<=
1
);
wire
z101
=
z75
||
z100
;
always
@(
posedge
z92
)
begin
if
(
z75
)
z44
<=
0
;
else
z44
<=
z40
&&
z41
&&
z43
&&
(!
z99
||
z100
||
!
z80
)
&&
!
z49
;
if
(
z75
)
z96
<=
0
;
else
z96
<=
z99
&&
!
z100
&&
z80
;
if
(
z101
)
z98
<=
z71
;
else
if
(
z99
)
z98
<=
z98
-
1
;
end
reg
signed
[
15
:
0
]
z102
,
z103
;
wire
z104
=
(
z38
[
15
:
01
]
==
15'b100000000000000
);
wire
z105
=
(
z38
[
31
:
17
]
==
15'b100000000000000
);
always
@(
posedge
z92
)
begin
z97
<=
!
z44
;
z45
<=
z81
?
z44
:
(
z44
||
z96
);
z46
<=
z45
&&
z80
;
z47
<=
z46
;
if
(
z97
)
z102
<=
0
;
else
z102
<=
{
z38
[
15
:
01
],
z38
[
00
]|
z104
};
if
(
z97
)
z103
<=
0
;
else
z103
<=
{
z38
[
31
:
17
],
z38
[
16
]|
z105
};
end
reg
z106
,
z107
,
z108
,
z109
,
z110
;
reg
[
3
:
0
]
z111
;
reg
[
6
:
0
]
z112
;
wire
z113
=
z108
&&
(
z111
>
0
);
always
@(
posedge
z92
)
begin
z106
<=
z44
;
z107
<=
z106
;
z108
<=
z107
;
z109
<=
z108
;
z112
<=
z38
[
15
]?
~
z38
[
14
:
8
]
:
z38
[
14
:
8
];
z110
<=
z107
&&
(
z112
>
z73
[
6
:
0
]);
if
(
z110
)
z111
<=
z73
[
11
:
8
];
else
if
(
z113
)
z111
<=
z111
-
1
;
end
wire
signed
[
15
:
0
]
z114
,
z115
;
dds
z116
(
z92
,
z75
,
z59
,
z60
,
z9
,
z45
,
z114
,
z115
);
reg
z117
,
z118
;
wire
signed
[
23
:
0
]
z119
,
z120
;
reg
signed
[
31
:
0
]
z121
,
z122
,
z123
,
z124
;
reg
signed
[
31
:
0
]
z125
,
z126
;
always
@(
posedge
z92
)
begin
z121
<=
(
z102
*
z115
);
z122
<=
(
z102
*
z114
);
z123
<=
(
z103
*
z115
);
z124
<=
(
z103
*
z114
);
if
(
z113
)
z125
<=
0
;
else
z125
<=
(
z121
-
z124
);
if
(
z113
)
z126
<=
0
;
else
z126
<=
(
z122
+
z123
);
z117
<=
z47
;
z118
<=
z47
;
end
assign
z120
=
z125
[
31
:
8
];
assign
z119
=
z126
[
31
:
8
];
wire
z127
,
z128
;
wire
signed
[
16
:
0
]
z129
,
z130
;
cicfilter
#
(
5
,
24
,
17
,
z24
,
z27
,
16
)
z131
(
z92
,
z75
,
z70
,
z55
,
z9
,
z117
,
z120
,
z127
,
z129
);
cicfilter
#
(
5
,
24
,
17
,
z24
,
z27
,
16
)
z132
(
z92
,
z75
,
z70
,
z55
,
z9
,
z118
,
z119
,
z128
,
z130
);
wire
z133
,
z134
;
wire
z135
,
z136
;
wire
[
16
:
0
]
z137
,
z138
;
firfilter
#
(
z25
,
17
,
16
,
17
,
3
,
8
,
`CFIRFLG
)
z139
(
z92
,
z75
,
z63
,
z64
,
z9
,
z133
,
z127
,
z129
,
z135
,
z137
,
z33
);
firfilter
#
(
z25
,
17
,
16
,
17
,
3
,
8
,
`CFIRFLG
)
z140
(
z92
,
z75
,
z63
,
z64
,
z9
,
z134
,
z128
,
z130
,
z136
,
z138
,
z33
);
wire
z141
,
z142
;
wire
[
16
:
0
]
z143
,
z144
;
resfilter
#
(
z26
,
17
,
18
,
17
,
3
,
8
,
2
)
z145
(
z92
,
z75
,
z93
,
z57
,
z56
,
z67
,
z68
,
z9
,
z141
,
z135
,{
z138
,
z137
},
z42
,
z142
,{
z144
,
z143
});
assign
z41
=
z141
;
wire
z146
,
z147
;
wire
z148
,
z149
;
wire
[
31
:
0
]
z150
,
z151
;
firfilter
#
(
z25
,
17
,
16
,
18
,
4
,
10
,
`PFIRFLG
)
z152
(
z92
,
z75
,
z65
,
z66
,
z9
,
z146
,
z142
,
z143
,
z148
,
z150
,
z89
);
firfilter
#
(
z25
,
17
,
16
,
18
,
4
,
10
,
`PFIRFLG
|
`DELAY1
)
z153
(
z92
,
z75
,
z65
,
z66
,
z9
,
z147
,
z142
,
z144
,
z149
,
z151
,
z33
);
assign
z42
=
z146
;
reg
[
6
:
0
]
z154
;
reg
[
31
:
0
]
z155
;
reg
z156
,
z157
;
always
@(
posedge
z92
)
begin
if
(
z75
)
z154
<=
0
;
else
if
(
z148
)
z154
<=
z154
+
1
;
if
(
z75
)
z156
<=
0
;
else
z156
<=
!
z79
||
z154
[
6
]
||
z156
;
z155
<=
z149
?
z151
:
z150
;
z157
<=
z156
&&
(
z148
||
z149
);
end
reg
z158
,
z159
,
z160
,
z161
;
reg
[
1
:
0
]
z162
;
always
@(
posedge
z92
)
begin
if
(
z75
)
z162
<=
0
;
else
if
(
z157
)
z162
<=
z162
+
1
;
end
always
@(
posedge
z92
)
begin
if
(
z75
)
z161
<=
0
;
else
if
(
z157
)
z161
<=
z80
&&
z89
&&
!
z162
[
1
];
end
wire
signed
[
24
:
0
]
z163
,
z164
,
z165
;
reg
signed
[
24
:
0
]
z166
;
wire
z167
,
z168
;
wire
z169
=
z88
&&
!
z91
;
wire
z170
=
z88
&&
z90
;
assign
z163
=
$signed
(
z155
[
27
:
3
]);
always
@(
posedge
z92
)
z166
<=
z161
?
-
z163
:
z163
;
roundN2Mc
#
(
25
,
16
,
1
)
z171
(
z166
,
z164
,
z169
,
z34
,
z92
,
z167
);
roundN2Mc
#
(
25
,
8
,
1
)
z172
(
z164
,
z165
,
z170
,
z34
,
z92
,
z168
);
reg
[
1
:
0
]
z173
;
always
@(
posedge
z92
)
begin
z158
<=
z157
;
z159
<=
z158
;
z160
<=
z159
;
if
(
z75
)
z173
<=
0
;
else
if
(
z159
)
z173
<=
z173
+
1
;
end
wire
z174
,
z175
;
wire
[
31
:
0
]
z176
;
`ifdef TFDD_DMOD
reg
[
15
:
0
]
z177
;
always
@(
posedge
z92
)
z177
<=
z164
[
23
:
8
];
demod_2dlut
z178
(
z92
,
z75
,
z61
,
z9
,
(
z159
&
z173
[
0
]),{
z164
[
23
:
8
],
z177
},
z174
,
z176
);
assign
z175
=
z83
;
`else
assign
z174
=
0
;
assign
z176
=
0
;
assign
z175
=
0
;
`endif
`ifdef BLNK_DEBUG
wire
z179
=
z109
;
wire
[
31
:
0
]
z180
=
{
z126
[
30
:
15
],
z125
[
30
:
15
]};
`else
wire
z179
=
z45
;
wire
[
31
:
0
]
z180
=
z38
;
`endif
reg
[
7
:
0
]
z181
;
reg
[
9
:
0
]
z182
;
wire
z183
=
z179
&&
(
z182
==
0
);
wire
z184
=
(
z181
==
z39
[
27
:
20
]);
always
@(
posedge
z92
)
begin
if
(
z75
)
z182
<=
0
;
else
if
(
z183
)
z182
<=
z70
;
else
if
(
z179
)
z182
<=
z182
-
1
;
if
(!
z94
)
z49
<=
z33
;
else
z49
<=
(
z181
>
z74
[
27
:
20
]);
if
(
z184
)
z181
<=
1
;
else
z181
<=
z181
+
1
;
end
reg
z185
;
reg
[
3
:
0
]
z186
;
reg
[
31
:
0
]
z187
;
always
@(
posedge
z92
)
begin
z187
<=
z175
?
z176
:
z80
?
{
z165
[
8
:
0
],
8'b0
,
z165
[
23
:
8
]}
:
z180
;
z185
<=
z175
?
z174
:
z80
?
z160
:
z183
;
z186
<=
z175
?
z85
:
z80
?
{
z33
,
z85
[
2
:
0
]}
:
z85
;
end
fifoNxMfmti
#
(
z3
,
32
)
z188
(
z13
,
z75
,
z186
,
z18
,
z19
,
z21
,
z35
,
z75
,
4'h8
,
z43
,
z185
,
z187
);
assign
z22
=
{
z142
,
z135
,
z44
,
z40
,
z14
,
z40
,
z43
,
z18
};
endmodule
