/**********************************************
 ICE Proprietary Software - do NOT disseminate
 **********************************************/
/*
  ICE-PIC Controller Defines

  Jeff Schoen
  Innovative Computer Engineering, Inc.
  1/15/2003

*/
`define ICE_PM 1
`define DTDM 1
`define VIRTEX2 1
`define NDRAM 1

`ifdef IO_HH
  `define CLOCKMODE 5
  `define OVS 5
  `define CLKT_112 1
`else
  `define CLOCKMODE 4
  `define OVS 4
`endif

`ifdef PE_NOOP
  `define ENGINE1 noopengine
  `define ENGINE2 noopengine
`elsif PE_NOOPX
  `define USEDELAYIT
  `define NDELAY 256
  `define ENGINE1 noopengine
  `define ENGINE2 noopengine
`elsif PE_FIR
  `define ENGINE1 firengine
  `define ENGINE2 firengine
`elsif PE_TFDD
  `define ENGINE1 tfddengine
  `define ENGINE2 tfddengine
`elsif PE_DMOD
  `define ENGINE1 dmodengine
  `define ENGINE2 dmodengine
`elsif PE_GSD
  `define ENGINE1 noopengine
  `define ENGINE2 gsdengine
`elsif PE_GSDX
  `define ENGINE1 nullengine
  `define ENGINE2 gsmxengine
`elsif PE_WAVE
  `define ENGINE1 waveengine
  `define ENGINE2 waveengine
`elsif PE_NULL
  `define ENGINE1 nullengine
  `define ENGINE2 nullengine
`elsif PE_USER
  `include "mdefs_user.h"
`endif
